from machine import Pin,SPI,PWM
import framebuf
import time

#color is BGR
RED = 0x00F8
GREEN = 0xE007
BLUE = 0x1F00
WHITE = 0xFFFF
BLACK = 0x0000

class lcd_1inch5(framebuf.FrameBuffer):
    def __init__(self):
    
        self.width = 240
        self.height = 280
        
        self.cs = Pin(9,Pin.OUT)
        self.rst = Pin(12,Pin.OUT)
        self.bl = Pin(13,Pin.OUT)
        self.cs(1)
        # pwm = PWM(Pin(13))#BL
        # pwm.freq(1000)        
        self.spi = SPI(1)
        self.spi = SPI(1,1000_000)
        self.spi = SPI(1,10000_000,polarity=0, phase=0,sck=Pin(10),mosi=Pin(11),miso=None)
        self.dc = Pin(8,Pin.OUT)
        self.dc(1)
        self.buffer = bytearray(self.height * self.width * 2)
        super().__init__(self.buffer, self.width, self.height, framebuf.RGB565)
        self.Init()
        self.SetWindows(0, 0, self.width-1, self.height-1)
        
    def reset(self):
        self.rst(1)
        time.sleep(0.2) 
        self.rst(0)
        time.sleep(0.2)         
        self.rst(1)
        time.sleep(0.2) 
        
    def write_cmd(self, cmd):
        self.dc(0)
        self.cs(0)
        self.spi.write(bytearray([cmd]))

    def write_data(self, buf):
        self.dc(1)
        self.cs(0)
        self.spi.write(bytearray([buf]))
        self.cs(1)

    def backlight(self,value):#value:  min:0  max:1000
        pwm = PWM(Pin(13))#BL
        pwm.freq(1000)
        if value>=1000:
            value=1000
        data=int (value*65536/1000)       
        pwm.duty_u16(data)  
        
    def Init(self):
        self.reset() 
        self.backlight(10000)
        
        self.write_cmd(0x36) 
        self.write_data(0x00) 
        
        self.write_cmd(0xfd) 
        self.write_data(0x06) 
        self.write_data(0x08) 

        self.write_cmd(0x61) 
        self.write_data(0x07) 
        self.write_data(0x04) 

        self.write_cmd(0x62) 
        self.write_data(0x00) #00
        self.write_data(0x44) #44
        self.write_data(0x45) #40  47

        self.write_cmd(0x63) #
        self.write_data(0x41) #
        self.write_data(0x07) #
        self.write_data(0x12) #
        self.write_data(0x12) #

        self.write_cmd(0x64) #
        self.write_data(0x37) #
	#VSP
        self.write_cmd(0x65) #Pump1=4.7MHz #PUMP1 VSP
        self.write_data(0x09) #D6-5:pump1_clk[1:0] clamp 28 2b
        self.write_data(0x10) #6.26
        self.write_data(0x21) 
	#VSN
        self.write_cmd(0x66)  #pump=2 AVCL
        self.write_data(0x09)  #clamp 08 0b 09
        self.write_data(0x10)  #10
        self.write_data(0x21) 
	#add source_neg_time
        self.write_cmd(0x67) #pump_sel
        self.write_data(0x21) #21 20
        self.write_data(0x40) 

	#gamma vap/van
        self.write_cmd(0x68) #gamma vap/van
        self.write_data(0x90) #
        self.write_data(0x4c) #
        self.write_data(0x50) #VCOM  
        self.write_data(0x70) #

        self.write_cmd(0xb1) #frame rate
        self.write_data(0x0F) #0x0f fr_h[5:0] 0F
        self.write_data(0x02) #0x02 fr_v[4:0] 02
        self.write_data(0x01) #0x04 fr_div[2:0] 04

        self.write_cmd(0xB4) 
        self.write_data(0x01)  #01:1dot 00:column
	##porch
        self.write_cmd(0xB5) 
        self.write_data(0x02) #0x02 vfp[6:0]
        self.write_data(0x02) #0x02 vbp[6:0]
        self.write_data(0x0a) #0x0A hfp[6:0]
        self.write_data(0x14) #0x14 hbp[6:0]

        self.write_cmd(0xB6) 
        self.write_data(0x04) #
        self.write_data(0x01) #
        self.write_data(0x9f) #
        self.write_data(0x00) #
        self.write_data(0x02) #
        ##gamme sel
        self.write_cmd(0xdf) #
        self.write_data(0x11) #gofc_gamma_en_sel=1
        ##gamma_test1 A1#_wangly
        #3030b_gamma_new_
        #GAMMA---------------------------------######/

        #GAMMA---------------------------------######/
        self.write_cmd(0xE2) 	
        self.write_data(0x03) #vrp0[5:0]	V0 03
        self.write_data(0x00) #vrp1[5:0]	V1 
        self.write_data(0x00) #vrp2[5:0]	V2 
        self.write_data(0x30) #vrp3[5:0]	V61 
        self.write_data(0x33) #vrp4[5:0]	V62 
        self.write_data(0x3f) #vrp5[5:0]	V63

        self.write_cmd(0xE5) 	
        self.write_data(0x3f) #vrn0[5:0]	V63
        self.write_data(0x33) #vrn1[5:0]	V62	
        self.write_data(0x30) #vrn2[5:0]	V61 
        self.write_data(0x00) #vrn3[5:0]	V2 
        self.write_data(0x00) #vrn4[5:0]	V1 
        self.write_data(0x03) #vrn5[5:0]  V0 03

        self.write_cmd(0xE1) 	
        self.write_data(0x05) #prp0[6:0]	V15
        self.write_data(0x67) #prp1[6:0]	V51 

        self.write_cmd(0xE4) 	
        self.write_data(0x67) #prn0[6:0]	V51 
        self.write_data(0x06) #prn1[6:0]  V15

        self.write_cmd(0xE0) 
        self.write_data(0x05) #pkp0[4:0]	V3 
        self.write_data(0x06) #pkp1[4:0]	V7  
        self.write_data(0x0A) #pkp2[4:0]	V21
        self.write_data(0x0C) #pkp3[4:0]	V29 
        self.write_data(0x0B) #pkp4[4:0]	V37 
        self.write_data(0x0B) #pkp5[4:0]	V45 
        self.write_data(0x13) #pkp6[4:0]	V56 
        self.write_data(0x19) #pkp7[4:0]	V60 

        self.write_cmd(0xE3) 	
        self.write_data(0x18) #pkn0[4:0]	V60 
        self.write_data(0x13) #pkn1[4:0]	V56 
        self.write_data(0x0D) #pkn2[4:0]	V45 
        self.write_data(0x09) #pkn3[4:0]	V37 
        self.write_data(0x0B) #pkn4[4:0]	V29 
        self.write_data(0x0B) #pkn5[4:0]	V21 
        self.write_data(0x05) #pkn6[4:0]	V7  
        self.write_data(0x06) #pkn7[4:0]	V3 
        #GAMMA---------------------------------######/

        #source
        self.write_cmd(0xE6) 
        self.write_data(0x00) 
        self.write_data(0xff) #SC_EN_START[7:0] f0

        self.write_cmd(0xE7) 
        self.write_data(0x01) #CS_START[3:0] 01
        self.write_data(0x04) #scdt_inv_sel cs_vp_en
        self.write_data(0x03) #CS1_WIDTH[7:0] 12
        self.write_data(0x03) #CS2_WIDTH[7:0] 12
        self.write_data(0x00) #PREC_START[7:0] 06
        self.write_data(0x12) #PREC_WIDTH[7:0] 12

        self.write_cmd(0xE8)  #source
        self.write_data(0x00)  #VCMP_OUT_EN 81-
        self.write_data(0x70)  #chopper_sel[6:4]
        self.write_data(0x00)  #gchopper_sel[6:4] 60
        ##gate
        self.write_cmd(0xEc) 
        self.write_data(0x52) #52

        self.write_cmd(0xF1) 
        self.write_data(0x01) #te_pol tem_extend 00 01 03
        self.write_data(0x01) 
        self.write_data(0x02) 


        self.write_cmd(0xF6) 
        self.write_data(0x01) 
        self.write_data(0x30) 
        self.write_data(0x00) #
        self.write_data(0x00) #40 

        self.write_cmd(0xfd) 
        self.write_data(0xfa) 
        self.write_data(0xfc) 

        self.write_cmd(0x3a) 
        self.write_data(0x55) #

        self.write_cmd(0x35) 
        self.write_data(0x00) 
        

        self.write_cmd(0x21)  

        self.write_cmd(0x11) 
        
        self.write_cmd(0x29) 
         
         
        
    def SetWindows(self, Xstart, Ystart, Xend, Yend):#example max:0,0,159,79
        Ystart=Ystart+20
        Yend=Yend+20
        self.write_cmd(0x2A);
        self.write_data((Xstart >> 8) & 0xFF);
        self.write_data(Xstart & 0xFF);
        self.write_data(((Xend  ) >> 8) & 0xFF);
        self.write_data((Xend  ) & 0xFF);

        self.write_cmd(0x2B);
        self.write_data((Ystart >> 8) & 0xFF);
        self.write_data(Ystart & 0xFF);
        self.write_data(((Yend  ) >> 8) & 0xFF);
        self.write_data((Yend  ) & 0xFF);

        self.write_cmd(0x2C) 
        
    def display(self):
    
        self.SetWindows(0,0,self.width-1,self.height-1)       
        self.dc(1)
        self.cs(0)
        self.spi.write(self.buffer)
        self.cs(1)        
     
    def write_text(self,text,x,y,size,color):
        background = self.pixel(x,y)
        info = []
        # Creating reference charaters to read their values
        self.text(text,x,y,color)
        for i in range(x,x+(8*len(text))):
            for j in range(y,y+8):
                # Fetching amd saving details of pixels, such as
                # x co-ordinate, y co-ordinate, and color of the pixel
                px_color = self.pixel(i,j)
                info.append((i,j,px_color)) if px_color == color else None
        # Clearing the reference characters from the screen
        self.text(text,x,y,background)
        # Writing the custom-sized font characters on screen
        for px_info in info:
            self.fill_rect(size*px_info[0] - (size-1)*x , size*px_info[1] - (size-1)*y, size, size, px_info[2]) 
    
if __name__=='__main__':

    lcd = lcd_1inch5()
    while True:
        lcd.fill(BLACK)
        lcd.SetWindows(0,0,240,280)
        lcd.write_text("Hello",65,70,3,GREEN)
        lcd.write_text("pico!",65,95,3,GREEN)   
        lcd.write_text("This is",38,130,3,GREEN)    
        lcd.write_text("1.5inch",68,160,2,GREEN)
        lcd.write_text("LCD Module",40,180,2,GREEN)
       
        lcd.hline(27,50,185,BLUE)
        lcd.hline(27,220,185,BLUE)
        lcd.vline(27,50,170,BLUE)
        lcd.vline(210,50,170,BLUE)
        
        lcd.hline(12,35,215,BLUE)
        lcd.hline(12,235,215,BLUE)
        lcd.vline(12,35,200,BLUE)
        lcd.vline(227,35,200,BLUE) 
        lcd.display()
        time.sleep(1)
        
        lcd.fill_rect(0,0,240,35,RED)
        lcd.rect(0,0,240,35,RED)
        lcd.fill_rect(0,35,240,35,BLUE)
        lcd.rect(0,35,240,35,BLUE)
        lcd.fill_rect(0,70,240,35,GREEN)
        lcd.rect(0,70,240,35,GREEN)
        lcd.fill_rect(0,105,240,35,0X07FF)
        lcd.rect(0,105,240,35,0X07FF)
        lcd.fill_rect(0,140,240,35,0xF81F)
        lcd.rect(0,140,240,35,0xF81F)
        lcd.fill_rect(0,175,240,35,0x7FFF)
        lcd.rect(0,175,240,35,0x7FFF)
        lcd.fill_rect(0,210,240,35,0xFFE0)
        lcd.rect(0,210,240,35,0xFFE0)
        lcd.fill_rect(0,245,240,35,0XF0F0)
        lcd.rect(0,245,240,35,0XF0F0)

        lcd.display()
        time.sleep(1)
    

   
